package net.plil.clubinfo.etunicorn.utils;

import android.content.Context;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.toolbox.Volley;

/**
 * Created by badetitou on 28/01/2017.
 */

public class VolleyUtils {

    private static final String uri = "http://192.168.0.21:8080/";
    private static final String version = "v1";

    public static final String baseUri = VolleyUtils.uri + VolleyUtils.version ;

    private static VolleyUtils mInstance;
    private RequestQueue  mRequestQueue;
    private static Context mCtx;

    private VolleyUtils(Context context) {
        mCtx = context;
        mRequestQueue = getRequestQueue();
    }

    public static synchronized VolleyUtils getInstance(Context context) {
        if (mInstance == null) {
            mInstance = new VolleyUtils(context);
        }
        return mInstance;
    }

    public RequestQueue getRequestQueue() {
        if (mRequestQueue == null) {
            // getApplicationContext() is key, it keeps you from leaking the
            // Activity or BroadcastReceiver if someone passes one in.
            mRequestQueue = Volley.newRequestQueue(mCtx.getApplicationContext());
        }
        return mRequestQueue;
    }

    public <T> void addToRequestQueue(Request<T> req) {
        getRequestQueue().add(req);
    }
}

